function S = normalize_vectors(S,dime)
% Normalize input vectors in S to a unit length. 
% 
% Inputs:
% S - matrix or vector containing data
% dime denotes if vectors in matrix S are row-vectors (dime = 'rows') 
% or column-vectors (dime = 'columns')
%
% Outputs:
% S - normalized vectors

if nargin ~= 2
    error('Number of inputs must be two!')
end
flipdim = 0;
switch dime
    case 'rows'
        S = S';
        flipdim = 1;
    case 'columns'
        
    otherwise
        error('dime must be ''rows'' or ''columns''!')
end

S = S./repmat(sqrt(sum(S.^2,1)),size(S,1),1);

if flipdim
    S = S';
end
