function resu = test_sparse_linear(Classifier, features, labels)
% Test a sparse linear classifier using the GLMNET-package. 
% 
% Inputs:
%
% Classifier - parameters of the trained classifier provided by glmnet
% features - a data matrix of features, where each row is one observation
% labels - labels of the features
% options - options-struct for glmnet (see glmnet.m, glmnetSet.m)
%
% Outputs:
% 
% resu - a structure containing test results:
% resu.acc          estimated classification accuracy
% resu.labelsEstim  esimated class labels
% resu.labelsTrue   true class labels


labels_estim = glmnetPredict(Classifier, features,[],'class');

Labels = repmat(labels(:),1,size(labels_estim,2));
resu.acc = sum(Labels == labels_estim,1)/length(labels);
resu.labelsEstim = labels_estim;
resu.labelsTrue = labels;



