function Classifier = train_sparse_linear(features_train,labels_train,options)
% Train a sparse linear classifier using the GLMNET-package. 
% 
% Inputs:
%
% features_train - training features 
% labels_train - labels of the training features
% options - options-struct for glmnet (see glmnet.m, glmnetSet.m)
%
% Outputs:
%
% Classifier - parameters of the trained classifier provided by glmnet

if length(unique(labels_train)) == 2 % two-category case
    classifierType = 'binomial';
else % multicategory case
    classifierType = 'multinomial'; 
end
Classifier = glmnet(features_train,labels_train(:),classifierType,options);
