function visualize_components(ICsVec,N,A,pos_map,plot_colormap,titl,maxCount)

% check inputs:
if nargin < 4
    error('Number of inputs must be at least four!')
end
if nargin < 5
   plot_colormap = 0;
   titl = '';
   maxCount = 0.1;
end
if nargin < 6
   titl = '';
   maxCount = 0.1;
end
if nargin < 7
   maxCount = 0.1;
end
if isempty(ICsVec)
    return
end

[aa,bb] = hist(ICsVec,1:N);
[compSorted,sai] = sort(aa,'descend');
compSortedInds = bb(sai);
fi = find(compSorted > 2);
if isempty(fi)
    warning('No stable components found...')
    return
else
    compSortedInds = compSortedInds(find(compSorted>2));    
    compSorted = compSorted(find(compSorted>2));    
    txt = 'Plotting most frequently appearing independent components: ';
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PLOT MORE INFO
% c = [];
% for m = 1:length(compSortedInds)
%    c = [c '#' num2str(compSortedInds(m)) ', '];
% end
% c(end-1:end) = [];
% disp([txt c])

% figure
% set(gcf,'Name',titl)
% bar(bb,aa);
% xlabel('Independent component');ylabel('count');
% title(['Frequency of components selected based on multiple classifier training']);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

stabilityIndex = compSorted/maxCount;
coefAll = compSortedInds';
coefAll(stabilityIndex < 0.80) = [];
if isempty(coefAll)
    warning('No stable components found...')
    return
end
coefAll = coefAll(1:min(length(coefAll),10));

figure
set(gcf,'Position',[30 70 610 560],'name',titl)
for m = 1:length(coefAll)
    if length(coefAll) > 5
        subplot(5,2,m)        
    else
        subplot(length(coefAll),1,m)
    end
    ICApatterns = A(:,coefAll(m));    
    % actual plotting commands are executed here:
    plot_array(ICApatterns','magnitude',pos_map);
    title(['Component #' num2str(coefAll(m)) ', magnitude'])
    % alternatively, plot component index with the stability value:
    % title(['Component #' num2str(coefAll(m)) ', magnitude, stability: ' num2str(compSorted(m)/maxCount)])
end
cmap1 = get(gcf,'Colormap');

figure
set(gcf,'Position',[670 70 610 560],'name',titl)
for m = 1:length(coefAll)
    if length(coefAll) > 5
        subplot(5,2,m)        
    else
        subplot(length(coefAll),1,m)
    end
    ICApatterns = A(:,coefAll(m));
    plot_array(ICApatterns','phase',pos_map);
    title(['Component #' num2str(coefAll(m)) ', phase'])
    % alternatively, plot component index with the stability value:
    % title(['Component #' num2str(coefAll(m)) ', phase, stability: ' num2str(compSorted(m)/maxCount)])
end
cmap2 = get(gcf,'Colormap');

if plot_colormap
    % plot colormap:
    figure;set(gcf,'Colormap',cmap1);
    h = colorbar('NorthOutside');set(h,'XTickLabel',[])
    title('Colorbar for magnitude plots: [0,...,1]');axis off;    
    figure;set(gcf,'Colormap',cmap2);
    h = colorbar('NorthOutside');set(h,'XTickLabel',[])
    title('Colorbar for phase plots: [-\pi/2,...,\pi/2]');axis off;
end


